defmodule TrixtaFlowsTest do
  use ExUnit.Case
  doctest TrixtaFlows

  setup do
    id = UUID.uuid1()

    flow_plain_map = %{
      "id" => id,
      "name" => "Genèsis Plain",
      "description" => "The Genèsis Plain Flow",
      "steps" => %{},
      "root_step" => nil
    }

    flow1_plain_map = %{
      "id" => "genesis_one_plain",
      "name" => "Genèsis One Plain",
      "description" => "The Genèsis One Plain Flow",
      "steps" => %{},
      "root_step" => nil
    }

    flow = %TrixtaFlows.Flow{
      id: id,
      name: "Genèsis",
      description: "The Genèsis Flow",
      versions: %{}
    }

    flow1 = %TrixtaFlows.Flow{
      name: "Genèsis One",
      description: "The Genèsis One Flow",
      versions: %{}
    }

    [flow_plain_map: flow_plain_map, flow1_plain_map: flow1_plain_map, flow: flow, flow1: flow1]
  end

  test "start_flow without params starts a new flow with defaults" do
    assert {:ok, pid, new_flow} = TrixtaFlows.start_flow()

    assert TrixtaFlows.FlowServer.flow_pid(new_flow.id) == pid
    assert new_flow.id != nil
    assert new_flow.name =~ ~r/^[a-z]+-[a-z]+-[0-9]+/
    assert new_flow.description =~ ~r/.+/
  end

  test "start_flow starts a new flow with given state plain map", %{
    flow_plain_map: flow_plain_map
  } do
    assert {:ok, pid, new_flow} = TrixtaFlows.start_flow(flow_plain_map)

    assert TrixtaFlows.FlowServer.flow_pid(new_flow.id) == pid
    assert new_flow.id != nil
    assert new_flow.id == flow_plain_map["id"]
    assert new_flow.name == "Genèsis Plain"
    assert new_flow.description == "The Genèsis Plain Flow"
  end

  test "start_flow starts a new flow with given state struct", %{flow: flow} do
    assert {:ok, pid, new_flow} = TrixtaFlows.start_flow(flow)

    assert TrixtaFlows.FlowServer.flow_pid(new_flow.id) == pid
    assert new_flow.id != nil
    assert new_flow.id == flow.id
    assert new_flow.name == "Genèsis"
    assert new_flow.description == "The Genèsis Flow"
  end

  test "start_flow without an ID starts a new flow with given state plain map and autogenerated ID",
       %{
         flow1_plain_map: flow1_plain_map
       } do
    assert {:ok, pid, new_flow} = TrixtaFlows.start_flow(flow1_plain_map)

    assert TrixtaFlows.FlowServer.flow_pid(new_flow.id) == pid
    assert new_flow.id != nil
    assert new_flow.name == "Genèsis One Plain"
    assert new_flow.description == "The Genèsis One Plain Flow"
  end

  test "start_flow without an ID starts a new flow with given state struct and autogenerated ID",
       %{
         flow1: flow1
       } do
    assert {:ok, pid, new_flow} = TrixtaFlows.start_flow(flow1)

    assert TrixtaFlows.FlowServer.flow_pid(new_flow.id) == pid
    assert new_flow.id != nil
    assert new_flow.name == "Genèsis One"
    assert new_flow.description == "The Genèsis One Flow"
  end

  test "stop_flow stops a given flow", %{flow: flow} do
    assert {:ok, pid, flow} = TrixtaFlows.start_flow(flow)
    assert TrixtaFlows.stop_flow(flow.id) == :ok
    assert TrixtaFlows.FlowServer.flow_pid(flow.id) == nil
  end

  test "terminate_flow terminates a named flow", %{flow: flow} do
    assert {:ok, pid, flow} = TrixtaFlows.start_flow(flow)
    assert TrixtaFlows.terminate_flow(flow.id) == :ok
    assert TrixtaFlows.FlowServer.flow_pid(flow.id) == nil
  end
end
